using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Purchase.PurchaseRequisition.Cqrs;

public record DeletePurchaseRequisitionByIdCommand(string Id) : IRequest<bool>;

public class DeletePurchaseRequisitionByIdHandler : IRequestHandler<DeletePurchaseRequisitionByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeletePurchaseRequisitionByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeletePurchaseRequisitionByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.PurchaseRequisition
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.PurchaseRequisition.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}